routes/web.php
<?php

use App\Http\Controllers\FormController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\SubscriptionController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', [HomeController::class, 'landing'])->name('landing');
Route::get('/subscription-form/{subscription}', [HomeController::class, 'form'])->name('subscriptionForm');
Route::post('/subscription-form/{subscription}', [HomeController::class, 'submit'])->name('submissionForm');

Auth::routes();

Route::group(['middleware' => 'auth'], function () {
    Route::get('/dashboard', [HomeController::class, 'index'])->name('dashboard');

    Route::middleware('role:admin')->prefix('user')->name('user.')->group(function () {
        Route::get('', [UserController::class, 'index'])->name('index');
        Route::get('/edit/{user}', [UserController::class, 'edit'])->name('edit');
        Route::post('/update/{user}', [UserController::class, 'update'])->name('update');
    });

    Route::middleware('role:admin')->prefix('subscription')->name('subscription.')->group(function () {
        Route::get('', [SubscriptionController::class, 'index'])->name('index');
        Route::get('/create', [SubscriptionController::class, 'create'])->name('create');
        Route::post('/store', [SubscriptionController::class, 'store'])->name('store');
        Route::get('/edit/{subscription}', [SubscriptionController::class, 'edit'])->name('edit');
        Route::put('/update/{subscription}', [SubscriptionController::class, 'update'])->name('update');
    });

    Route::middleware('role:admin')->prefix('form')->name('form.')->group(function () {
        Route::get('', [FormController::class, 'index'])->name('index');
        Route::get('/create', [FormController::class, 'create'])->name('create');
        Route::post('/store', [FormController::class, 'store'])->name('store');
        Route::get('/edit/{form}', [FormController::class, 'edit'])->name('edit');
        Route::put('/update/{form}', [FormController::class, 'update'])->name('update');
        Route::get('/builder/{form}', [FormController::class, 'builder'])->name('builder');
        Route::post('/builder/{form}', [FormController::class, 'storeBuilder'])->name('builder.store');
    });
});

app/Http/Controllers/FormController.php
<?php

namespace App\Http\Controllers;

use App\Models\Form;
use App\Models\FormField;
use Illuminate\Http\Request;
use RealRashid\SweetAlert\Facades\Alert;

class FormController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return view('form.index');
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('form.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required|string',
            'description' => 'required|string|min:3'
        ]);

        Form::create($request->all());

        Alert::success('Success!', 'Form created successfully');

        return redirect()->route('form.index');
    }

    /**
     * Display the specified resource.
     */
    public function builder(Form $form)
    {
        return view('form.builder', ['form' => $form]);
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Form $form)
    {
        return view('form.edit', ['form' => $form]);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Form $form)
    {
        $request->validate([
            'name' => 'required|string',
            'description' => 'required|string|min:3'
        ]);

        $form->update($request->all());

        Alert::success('Success!', 'Form updated successfully');

        return redirect()->route('form.index');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function storeBuilder(Request $request, Form $form)
    {
        $request->validate([
            'form_builder' => 'required|array|min:1',
            'form_builder.*.type' => 'required|string|min:3',
            'form_builder.*.label' => 'required|string|min:3',
            'form_builder.*.is_required' => 'nullable',
            'form_builder.*.options' => 'nullable|required_if:form_builder.*.type,select,radio,checkbox|string|min:3',
        ]);

        foreach ($request->form_builder as $field) {

            $array = explode(",", $field['options']);

            $form->fields()->create([
                'type' => $field['type'],
                'label' => $field['label'],
                'is_required' => isset($field['is_required']) ? $field['is_required'][0] : 0,
                'options' => $array
            ]);
        }

        Alert::success('Success', 'Form fields created successfully!');

        return redirect()->route('form.index');
    }
}

app/Livewire/FormTable.php
<?php

namespace App\Livewire;

use App\Models\Form;
use Livewire\Attributes\Url;
use Livewire\Component;
use Livewire\WithPagination;

class FormTable extends Component
{
    use WithPagination;

    #[Url(history: true)]
    public $perPage = 5;

    #[Url(history: true)]
    public $search = "";

    #[Url(history: true)]
    public $sortBy = "created_at";

    #[Url(history: true)]
    public $sortDir = "desc";

    protected $listeners = ['deleteForm', 'deleteFormBuilder'];

    public function updatedSearch()
    {
        $this->resetPage();
    }

    public function setSortBy($sortByField)
    {
        if ($this->sortBy == $sortByField) {
            $this->sortDir = ($this->sortDir == "asc") ? "desc" : "asc";
            return;
        }
        $this->sortBy = $sortByField;
        $this->sortDir = "desc";
    }

    public function render()
    {
        $forms = Form::search($this->search)->orderBy($this->sortBy, $this->sortDir)->paginate($this->perPage);

        return view('livewire.form-table', [
            'forms' => $forms,
            'totalResults' => $forms->total(),
            'firstResult' => $forms->firstItem(),
            'lastResult' => $forms->lastItem()
        ]);
    }

    public function confirmDeleteForm($id)
    {
        $this->dispatch('swal:confirm', type: 'question', text: 'Are you sure you want to delete this form ? It will automatically deleted the associated subscription.', id: $id, listener: 'deleteForm');
    }

    public function confirmDeleteFormBuilder($id)
    {
        $this->dispatch('swal:confirm', type: 'question', text: 'Are you sure you want to delete this form builder?', id: $id, listener: 'deleteFormBuilder');
    }

    public function deleteForm($id)
    {
        $form = Form::find($id);

        if ($form->subscription()->exists()) {
            $form->subscription()->delete();
        }

        $form->delete();

        $this->dispatch('swal:modal', type: 'success', text: 'Form deleted successfully', title: 'Success!');
    }

    public function deleteFormBuilder($id)
    {
        $form = Form::find($id);

        $form->fields()->delete();

        $this->dispatch('swal:modal', type: 'success', text: 'Form builder deleted successfully', title: 'Success!');
    }
}

resources/views/form/builder.blade.php
@extends('layouts.main')

@section('content')
    <div class="row mb-5 mb-xl-10">
        <div class="card mb-5 mb-xl-10">
            <!--begin::Card header-->
            <div class="card-header border-0 cursor-pointer" role="button" data-bs-toggle="collapse" data-bs-target="#kt_account_profile_details" aria-expanded="true"
                aria-controls="kt_account_profile_details">
                <!--begin::Card title-->
                <div class="card-title m-0">
                    <h3 class="fw-bold m-0">Form Builder</h3>
                </div>
                <!--end::Card title-->
            </div>
            <!--begin::Card header-->
            <!--begin::Content-->
            <!--begin::Form-->
            <form class="form fv-plugins-bootstrap5 fv-plugins-framework" method="POST" action="{{ route('form.builder.store', $form) }}">
                @csrf
                <!--begin::Card body-->
                <div class="card-body border-top p-9">
                    <!--begin::Repeater-->
                    <div id="kt_docs_repeater_basic">
                        <!--begin::Form group-->
                        <div class="form-group">
                            <div data-repeater-list="form_builder">
                                <div data-repeater-item>
                                    <div class="form-group row mb-3">
                                        <div class="col-md-2">
                                            <label class="form-label">Type:</label>
                                            <select class="form-select" aria-label="Select Type" name="type">
                                                <option value="{{ null }}">Open this select menu</option>
                                                <option value="text">Text</option>
                                                <option value="email">Email</option>
                                                <option value="checkbox">Checkbox</option>
                                                <option value="radio">RadioButton</option>
                                                <option value="select">Dropdown Select</option>
                                            </select>
                                            @error('form_builder.*.type')
                                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                                            @enderror
                                        </div>
                                        <div class="col-md-4">
                                            <label class="form-label">Label:</label>
                                            <input type="text" class="form-control mb-2 mb-md-0" name="label" />
                                            @error('form_builder.*.label')
                                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                                            @enderror
                                        </div>
                                        <div class="col-md-2">
                                            <div class="form-check form-check-custom form-check-solid mt-2 mt-md-11">
                                                <input class="form-check-input" type="checkbox" value="1" name="is_required" />
                                                <label class="form-check-label" for="form_checkbox">
                                                    Is Required ?
                                                </label>
                                            </div>
                                            @error('form_builder.*.is_required')
                                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                                            @enderror
                                        </div>
                                        <div class="col-md-3">
                                            <label class="form-label">Options:</label>
                                            <input type="text" class="form-control mb-2 mb-md-0" name="options" />
                                            @error('form_builder.*.options')
                                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                                            @enderror
                                        </div>
                                        <div class="col-md-1">
                                            <a href="javascript:;" data-repeater-delete class="btn btn-sm btn-light-danger mt-3 mt-md-8">
                                                <i class="ki-duotone ki-trash fs-5"><span class="path1"></span><span class="path2"></span><span class="path3"></span><span class="path4"></span><span
                                                        class="path5"></span></i>
                                            </a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!--end::Form group-->

                        <!--begin::Form group-->
                        <div class="form-group mt-5">
                            <a href="javascript:;" data-repeater-create class="btn btn-light-primary">
                                <i class="ki-duotone ki-plus fs-3"></i>
                                Add
                            </a>
                        </div>
                        <!--end::Form group-->
                    </div>
                    <!--end::Repeater-->
                </div>
                <!--end::Card body-->
                <!--begin::Actions-->
                <div class="card-footer d-flex justify-content-end py-6 px-9">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
                <!--end::Actions-->
            </form>
            <!--end::Form-->
            <!--end::Content-->
        </div>
    </div>
@endsection

@push('script')
    <script>
        $('#kt_docs_repeater_basic').repeater({
            initEmpty: false,

            defaultValues: {
                'text-input': 'foo'
            },

            show: function() {
                $(this).slideDown();
            },

            hide: function(deleteElement) {
                $(this).slideUp(deleteElement);
            }
        });
    </script>
@endpush

resources/views/form/create.blade.php
@extends('layouts.main')

@section('content')
    <div class="row mb-5 mb-xl-10">
        <div class="card mb-5 mb-xl-10">
            <!--begin::Card header-->
            <div class="card-header border-0 cursor-pointer" role="button" data-bs-toggle="collapse" data-bs-target="#kt_account_profile_details" aria-expanded="true"
                aria-controls="kt_account_profile_details">
                <!--begin::Card title-->
                <div class="card-title m-0">
                    <h3 class="fw-bold m-0">Create Form</h3>
                </div>
                <!--end::Card title-->
            </div>
            <!--begin::Card header-->
            <!--begin::Content-->
            <!--begin::Form-->
            <form class="form fv-plugins-bootstrap5 fv-plugins-framework" method="POST" action="{{ route('form.store') }}">
                @csrf
                <!--begin::Card body-->
                <div class="card-body border-top p-9">
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Form Name</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8">
                            <input type="text" name="name" class="form-control form-control-lg form-control-solid mb-3 mb-lg-0" value="{{ old('name') }}">
                            @error('name')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Description</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <textarea name="description" class="form-control form-control form-control-solid" rows="4" data-kt-autosize="true">{{ old('description') }}</textarea>
                            @error('description')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                </div>
                <!--end::Card body-->
                <!--begin::Actions-->
                <div class="card-footer d-flex justify-content-end py-6 px-9">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
                <!--end::Actions-->
            </form>
            <!--end::Form-->
            <!--end::Content-->
        </div>
    </div>
@endsection

resources/views/form/edit.blade.php
@extends('layouts.main')

@section('content')
    <div class="row mb-5 mb-xl-10">
        <div class="card mb-5 mb-xl-10">
            <!--begin::Card header-->
            <div class="card-header border-0 cursor-pointer" role="button" data-bs-toggle="collapse" data-bs-target="#kt_account_profile_details" aria-expanded="true"
                aria-controls="kt_account_profile_details">
                <!--begin::Card title-->
                <div class="card-title m-0">
                    <h3 class="fw-bold m-0">Edit Form</h3>
                </div>
                <!--end::Card title-->
            </div>
            <!--begin::Card header-->
            <!--begin::Content-->
            <!--begin::Form-->
            <form class="form fv-plugins-bootstrap5 fv-plugins-framework" method="POST" action="{{ route('form.update', $form) }}">
                @method('PUT')
                @csrf
                <!--begin::Card body-->
                <div class="card-body border-top p-9">
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Form Name</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8">
                            <input type="text" name="name" class="form-control form-control-lg form-control-solid mb-3 mb-lg-0" value="{{ $form->name }}">
                            @error('name')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Description</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <textarea name="description" class="form-control form-control form-control-solid" rows="4" data-kt-autosize="true">{{ $form->description }}</textarea>
                            @error('description')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                </div>
                <!--end::Card body-->
                <!--begin::Actions-->
                <div class="card-footer d-flex justify-content-end py-6 px-9">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
                <!--end::Actions-->
            </form>
            <!--end::Form-->
            <!--end::Content-->
        </div>
    </div>
@endsection

resources/views/form/index.blade.php
@extends('layouts.main')

@section('content')
    <!--begin::Row-->
    <div class="row mb-5 mb-xl-10">
        <div class="card shadow-sm">
            <div class="card-header">
                <h3 class="card-title">Form List</h3>
                <div class="card-toolbar">
                    <a href="{{ route('form.create') }}" class="btn btn-sm btn-primary">
                        Add
                    </a>
                </div>
            </div>
            <div class="card-body">
                @livewire('form-table')
            </div>
        </div>
    </div>
    <!--end::Row-->
@endsection